Package org.apache.cayenne.query

## Class Orderings

- java.lang.Object
- - java.util.AbstractCollection<E>
  - - java.util.AbstractList<E>
    - - java.util.ArrayList<Ordering>
      - - org.apache.cayenne.query.Orderings

- All Implemented Interfaces:
    `Serializable`, `Cloneable`, `Iterable<Ordering>`, `Collection<Ordering>`, `List<Ordering>`, `RandomAccess`

      public class Orderings
      extends ArrayList<Ordering>

  Orderings is provided so that you can chain Ordering together and then use the result to pass into methods that require List<Ordering>

  Example:

      Person.COMPANY_NAME.asc().then(Person.FIRST_NAME.desc)

  Since:
    4.1
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class java.util.AbstractList

      `modCount`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Orderings()` |
    `Orderings​(int initialCapacity)` |
    `Orderings​(Collection<? extends Ordering> c)` |
    `Orderings​(Ordering ordering)` |
    `Orderings​(Ordering... orderings)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `<T> List<T>` | `orderedList​(List<T> list)` | Returns an list sorted with these Orderings.
    `<T> void` | `orderList​(List<T> list)` | Sorts the given array with these Orderings.
    `Orderings` | `then​(List<Ordering> nextOrderings)` |
    `Orderings` | `then​(Ordering nextOrdering)` | Adds the given sort ordering to the end of this list and returns "this" so it can be chained again.
    `Orderings` | `then​(Orderings nextOrderings)` | Adds the given sort orderings to the end of this list and returns "this" so it can be chained again.

    - ### Methods inherited from class java.util.ArrayList

      `add, add, addAll, addAll, clear, clone, contains, ensureCapacity, equals, forEach, get, hashCode, indexOf, isEmpty, iterator, lastIndexOf, listIterator, listIterator, remove, remove, removeAll, removeIf, removeRange, replaceAll, retainAll, set, size, sort, spliterator, subList, toArray, toArray, trimToSize`

    - ### Methods inherited from class java.util.AbstractCollection

      `containsAll, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Collection

      `parallelStream, stream, toArray`

    - ### Methods inherited from interface java.util.List

      `containsAll`

- - ### Constructor Detail

    - #### Orderings

          public Orderings()

    - #### Orderings

          public Orderings​(int initialCapacity)

    - #### Orderings

          public Orderings​(Collection<? extends Ordering> c)

    - #### Orderings

          public Orderings​(Ordering ordering)

    - #### Orderings

          public Orderings​(Ordering... orderings)

  - ### Method Detail

    - #### then

          public Orderings then​(Ordering nextOrdering)

      Adds the given sort ordering to the end of this list and returns "this" so it can be chained again.
      Parameters:
        `nextOrdering` - the sort ordering to add
      Returns:
        this (with nextOrdering appended)

    - #### then

          public Orderings then​(Orderings nextOrderings)

      Adds the given sort orderings to the end of this list and returns "this" so it can be chained again.
      Parameters:
        `nextOrderings` - the sort ordering to add
      Returns:
        this (with nextOrderings appended)

    - #### then

          public Orderings then​(List<Ordering> nextOrderings)

      Parameters:
        `nextOrderings` - the sort ordering to add
      Returns:
        this
      See Also:
        `then(Orderings)`

    - #### orderedList

          public <T> List<T> orderedList​(List<T> list)

      Returns an list sorted with these Orderings.
      Type Parameters:
        `T` - the type of the list
      Parameters:
        `list` - the list to sort
      Returns:
        a sorted copy of the list

    - #### orderList

          public <T> void orderList​(List<T> list)

      Sorts the given array with these Orderings.
      Type Parameters:
        `T` - the type of the list
      Parameters:
        `list` - the list to sort